#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
#include <i86.h>
#include <string.h>

#define SHIFT_PRESSED ((*(unsigned char __far*)MK_FP(0x40, 0x17)) & 0x3)
#define CAPS_LOCK ((*(unsigned char __far*)MK_FP(0x40, 0x17)) & 0x40)
#define ALTGR_PRESSED ((*(unsigned char __far*)MK_FP(0x40, 0x96)) & 0x08)

unsigned char inbyte(unsigned long);
#pragma aux inbyte = \
  "in al, dx" \
  value [al] parm [dx];

unsigned current_psp(void);
#pragma aux current_psp = \
  "mov ah, 0x51" \
  "int 0x21" \
  value [bx] modify [ax];

int dos_close(unsigned handle);
#pragma aux dos_close = \
  "mov ah, 0x3e" \
  "int 0x21" \
  parm [bx] value [ax];

void __far *dos_alloc(unsigned bytes);
#pragma aux dos_alloc = \
  "push cx" \
  "mov cl, 4" \
  "add bx, 0xF" \
  "shr bx, cl" \
  "pop cx" \
  "mov ah, 0x48" \
  "int 0x21" \
  "jnc end" \
  "xor ax, ax" \
  "end:" \
  "xor dx, dx" \
  "xchg ax, dx" \
  parm [bx] value [dx ax];

void __far dos_free(unsigned seg);
#pragma aux dos_free = \
  "mov ah, 0x49" \
  "mov es, bx" \
  "int 0x21" \
  parm [bx] modify [es ax];


struct keycode 
{
  unsigned char normal;
  unsigned char shift;
  unsigned char caps;
  unsigned char altgr;
  unsigned char alt_caps;
  unsigned dead:1;
};

struct dead_key_comb
{
  unsigned char letter;
  unsigned char diacritic;
  unsigned char result;
};

/*struct keycode __far * __based(__segname("_CODE")) key_table;
struct dead_key_comb __far * __based(__segname("_CODE")) dkc;
unsigned __based(__segname("_CODE")) kccnt = 0;*/

struct local_ptrs
{
  struct keycode __far * key_table;
  struct dead_key_comb __far* dkc;
  unsigned kccnt;
}
  __based(__segname("_CODE")) local_ptrs;

unsigned __based(__segname("_CODE")) my_psp;

unsigned char __based(__segname("_CODE")) dead_key_pressed = 0;
unsigned char __based(__segname("_CODE")) special_key_pressed = 0;

extern void __far * __based(__segname("_CODE")) bios_kbd_hdl;
extern void __far * __based(__segname("_CODE")) old_int2f_hdl;

void __interrupt kbd_hdl(void);
void __interrupt int2fhdl();

void set_memory_allocation_strategy(unsigned strategy);
#pragma aux set_memory_allocation_strategy = \
  "mov ax, 0x5801" \
  "int 0x21" \
  parm [bx];

int keyb_is_installed(void);

struct local_ptrs __far* get_keyb_ptrs(void);
#pragma aux get_keyb_ptrs = \
  "mov ax, 0xAD87" \
  "int 0x2F" \
  value [dx ax];

struct keyb_ptrs
{
  struct keycode __far * __far * key_table;
  struct dead_key_comb __far * __far *dkc;
  unsigned __far* kccnt;
};

struct keyb_ptrs get_ptr_struct(void)
{
  struct local_ptrs __far *ptr;
  struct keyb_ptrs retval;
  if(keyb_is_installed())
  {
    puts("Keyb is already installed - changing keyboard layout...");
    ptr = get_keyb_ptrs();
    retval.key_table = &ptr->key_table;
    retval.dkc = &ptr->dkc;
    retval.kccnt = &ptr->kccnt;
    *retval.kccnt = 0;
    dos_free(FP_SEG(*retval.dkc));
  }
  else
  {
    retval.key_table = &local_ptrs.key_table;
    retval.dkc = &local_ptrs.dkc;
    retval.kccnt = &local_ptrs.kccnt;
  }
  return retval;
}

void update_key_table(FILE *fp)
{
  char buff[64];
  unsigned keycode;
  char *ptr;
  struct keyb_ptrs ptrs = get_ptr_struct();

  set_memory_allocation_strategy(2);
  if(!*ptrs.key_table)
    *ptrs.key_table = dos_alloc(0x80*sizeof(struct keycode));
  if(!*ptrs.key_table)
  {
    puts("Out of memory.");
    set_memory_allocation_strategy(0);
    exit(1);
  }
  _fmemset(*ptrs.key_table, 0, 0x80*sizeof(struct keycode));

  while(fgets(buff, sizeof(buff), fp))
  {
    keycode = strtoul(buff, &ptr, 0x10);
    if(keycode == 0xDEAD)
      ++*ptrs.kccnt;
  }
  *ptrs.dkc = dos_alloc(*ptrs.kccnt*sizeof(struct dead_key_comb));
  if(!*ptrs.dkc)
  {
    puts("Not enough memory - cannot allocate space for dead keys");
    *ptrs.kccnt = -1;
  }
  else
    *ptrs.kccnt = 0;
  set_memory_allocation_strategy(0);

  rewind(fp);

  while(fgets(buff, sizeof(buff), fp))
  {
    ptr = buff;
    keycode = strtoul(ptr, &ptr, 0x10);

    if(keycode == 0xDEAD)
    {
      if(*ptrs.kccnt == -1) continue;
      (*ptrs.dkc)[*ptrs.kccnt].letter = strtoul(ptr+1, &ptr, 0x10);
      (*ptrs.dkc)[*ptrs.kccnt].diacritic = strtoul(ptr+1, &ptr, 0x10);
      (*ptrs.dkc)[*ptrs.kccnt].result = strtoul(ptr+1, &ptr, 0x10);
      printf("Dead key + letter combination %u: %c + %c = %c\n", *ptrs.kccnt, (*ptrs.dkc)[*ptrs.kccnt].letter,
             (*ptrs.dkc)[*ptrs.kccnt].diacritic, (*ptrs.dkc)[*ptrs.kccnt].result);
      ++*ptrs.kccnt;
    }
    else
    {
      (*ptrs.key_table)[keycode].normal = strtoul(ptr+1, &ptr, 0x10);
      (*ptrs.key_table)[keycode].caps = strtoul(ptr+1, &ptr, 0x10);
      (*ptrs.key_table)[keycode].shift = strtoul(ptr+1, &ptr, 0x10);
      (*ptrs.key_table)[keycode].altgr = strtoul(ptr+1, &ptr, 0x10);
      (*ptrs.key_table)[keycode].alt_caps = strtoul(ptr+1, &ptr, 0x10);
      if(*ptr && strtoul(ptr+1, &ptr, 0x10) == 0xDEAD)
        (*ptrs.key_table)[keycode].dead = 1;
      printf("Keycode %.2X: normal %c, caps %c, shift %c,\
 alt gr %c, alt caps %c, dead=%u\n", keycode,
             (*ptrs.key_table)[keycode].normal, (*ptrs.key_table)[keycode].caps,
             (*ptrs.key_table)[keycode].shift, (*ptrs.key_table)[keycode].altgr,
             (*ptrs.key_table)[keycode].alt_caps, (*ptrs.key_table)[keycode].dead);
    }
  }
}

int read_keymap(char *filename)
{
  FILE *fp;
  char path[100];
  char *keybenv = getenv("KEYBDIR");

  if(keybenv)
    sprintf(path, "%s/%s", keybenv, filename);
  else
    strcpy(path, filename);

  fp = fopen(path, "rt");
  if(!fp)
  {
    printf("Cannot find file %s\n", path);
    exit(1);
  }
  update_key_table(fp);
  fclose(fp);

  if(keyb_is_installed())
    exit(0);

  return 0;
}

int keyb_is_installed(void)
{
  int retval;

  __asm
  {
    mov ax, 0xAD80
    xor bx, bx
    int 0x2F
    mov retval, bx
  }
  if(retval != -1)
    return 0;
  return -1;
}

void unload(void)
{
  __asm
  {
    mov ax, 0xAD86
    int 0x2F
  }
}

extern void __far * __based(__segname("_CODE")) int21_handler;

#pragma aux main aborts;
void main(int argc, char *argv[])
{
  unsigned env_seg;
  unsigned n;
  unsigned char __far *psp_ptr = MK_FP(my_psp = current_psp(), 0);

  puts("ST-DOS KEYB v. 0.3");

  if(argc < 2)
  {
    puts("Usage: >KEYB [mapfile]");
    exit(1);
  }

  if(!strcmp(argv[1], "/UNLOAD"))
    if(keyb_is_installed())
    {
      puts("Unloading KEYB...");
      unload();
      exit(0);
    }
    else
    {
      puts("Error: KEYB is not loaded!");
      exit(1);
    }

  read_keymap(argv[1]);

  bios_kbd_hdl = _dos_getvect(9);
  _dos_setvect(9, kbd_hdl);
  old_int2f_hdl = _dos_getvect(0x2F);
  _dos_setvect(0x2F, int2fhdl);
  int21_handler = _dos_getvect(0x21);


  env_seg = *(unsigned __far*)&psp_ptr[0x2C];
  dos_free(env_seg);

  for(n=3;n--;)
    dos_close(n);

  _dos_keep(0, 0x10 + ((FP_OFF(get_ptr_struct) + 0xF) >> 4));
}
