#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
#include <i86.h>
#include <string.h>

#define SHIFT_PRESSED ((*(unsigned char __far*)MK_FP(0x40, 0x17)) & 0x3)
#define CAPS_LOCK ((*(unsigned char __far*)MK_FP(0x40, 0x17)) & 0x40)
#define ALTGR_PRESSED ((*(unsigned char __far*)MK_FP(0x40, 0x96)) & 0x08)
#define LEFTALT_PRESSED ((*(unsigned char __far*)MK_FP(0x40, 0x18)) & 0x02)
#define CTRL_PRESSED ((*(unsigned char __far*)MK_FP(0x40, 0x17)) & 0x04)

unsigned char inbyte(unsigned long);
#pragma aux inbyte = \
  "in al, dx" \
  value [al] parm [dx];


void __far dos_free(unsigned seg);
#pragma aux dos_free = \
  "mov ah, 0x49" \
  "mov es, bx" \
  "int 0x21" \
  parm [bx] modify [es ax];


struct keycode 
{
  unsigned char normal;
  unsigned char shift;
  unsigned char caps;
  unsigned char altgr;
  unsigned char alt_caps;
  unsigned dead:1;
};

struct dead_key_comb
{
  unsigned char letter;
  unsigned char diacritic;
  unsigned char result;
};

/*extern struct keycode __far * __based(__segname("_CODE")) key_table;
extern struct dead_key_comb __far * __based(__segname("_CODE")) dkc;
extern unsigned __based(__segname("_CODE")) kccnt;*/

struct local_ptrs
{
  struct keycode __far * key_table;
  struct dead_key_comb __far* dkc;
  unsigned kccnt;
}
  extern __based(__segname("_CODE")) local_ptrs;

extern void __far * __based(__segname("_CODE")) bios_kbd_hdl;
extern void __far * __based(__segname("_CODE")) old_int2f_hdl;

void dos_setvect(unsigned char vector, void __far *fptr);
#pragma aux dos_setvect = \
  "push ds" \
  "push es" \
  "pop ds" \
  "mov ah, 0x25" \
  "int 0x21" \
  "pop ds" \
  parm [al] [es dx];

void unload_keyb(void)
{
  dos_setvect(0x09, bios_kbd_hdl);
  dos_setvect(0x2F, old_int2f_hdl);
  dos_free(FP_SEG(local_ptrs.key_table));
  dos_free(FP_SEG(local_ptrs.dkc));
}

extern unsigned char __based(__segname("_CODE")) dead_key_pressed;
extern unsigned char __based(__segname("_CODE")) special_key_pressed;

#define KBD_BUFFER_HEAD (*(unsigned __far*)MK_FP(0x40, 0x1A))
#define KBD_BUFFER_TAIL (*(unsigned __far*)MK_FP(0x40, 0x1C))
#define BIOS_DATA ((unsigned char __far*)MK_FP(0x40, 0x00))
// these don't exist in the first revisions of the IBM PC BIOS
//#define BUFFER_END (*(unsigned __far*)MK_FP(0x40, 0x82))
//#define BUFFER_START (*(unsigned __far*)MK_FP(0x40, 0x80))
#define BUFFER_START 0x1E
#define BUFFER_END 0x3E

char put_keycode(unsigned char keycode, unsigned char chr)
{
/*  char retval;
// this only works on AT compatibles
  __asm
  {
    mov ch, keycode
    mov cl, chr
    mov ah, 5
    int 0x16
    mov retval, al
  }
  return retval;*/

// this should work on every PC compatible...
  if(KBD_BUFFER_HEAD == KBD_BUFFER_TAIL+2 ||
     (KBD_BUFFER_HEAD == BUFFER_END-2 && KBD_BUFFER_TAIL == BUFFER_START))
    return 1;

  BIOS_DATA[KBD_BUFFER_TAIL++] = chr;
  BIOS_DATA[KBD_BUFFER_TAIL++] = keycode;

  if(KBD_BUFFER_TAIL == BUFFER_END)
    KBD_BUFFER_TAIL = BUFFER_START;

  return 0;
}

#pragma aux getcode value [al] modify exact [ax];
unsigned char getcode(void)
{
  unsigned char keycode = inbyte(0x60);
  unsigned char chr;
  unsigned n;

  if((keycode & 0x7F) == 0x38)
  {
    special_key_pressed = 0;
    return 0;
  }
  if(LEFTALT_PRESSED || CTRL_PRESSED)
    return 0;
  if(special_key_pressed == 0xFF)
  {
    special_key_pressed = keycode;
    return 0;
  }
  if(!special_key_pressed)
  {
    if(keycode == 0xE0)
    {
      special_key_pressed = 0xFF;
      return 0;
    }
  }
  else
  {
    if(keycode == (special_key_pressed | 0x80))
      special_key_pressed = 0;
    return 0;
  }
  if((keycode & 0x80) || keycode == 0x2A || keycode == 0x36) return 0;

  if(ALTGR_PRESSED)
  {
    if(!(SHIFT_PRESSED | CAPS_LOCK))
      chr = local_ptrs.key_table[keycode].altgr;
    else
      chr = local_ptrs.key_table[keycode].alt_caps;
  }
  else if(SHIFT_PRESSED)
  {
    chr = local_ptrs.key_table[keycode].shift;
    if(!chr)
      if(!CAPS_LOCK)
        chr = local_ptrs.key_table[keycode].caps;
      else
        chr = local_ptrs.key_table[keycode].normal;
  }
  else if(CAPS_LOCK) chr = local_ptrs.key_table[keycode].caps;
  else chr = local_ptrs.key_table[keycode].normal;

  if(chr)
  {
    if(local_ptrs.key_table[keycode].dead)
      if(!dead_key_pressed)
        return dead_key_pressed = chr;
    if(dead_key_pressed)
    {
      if(dead_key_pressed != chr)
      {
        for(n=local_ptrs.kccnt;n--;)
          if(local_ptrs.dkc[n].letter == chr && local_ptrs.dkc[n].diacritic == dead_key_pressed)
          {
            chr = local_ptrs.dkc[n].result;
            break;
          }
        if(n == -1)
          put_dead_key:if(put_keycode(keycode, dead_key_pressed))
            return 0;
      }
      dead_key_pressed = 0;
    }
    if(put_keycode(keycode, chr))
      return 0;
  }
  else if(dead_key_pressed) goto put_dead_key;

  return chr;
}
