.8086

.MODEL small

_TEXT               SEGMENT BYTE PUBLIC USE16 'CODE'
                ASSUME CS:_TEXT                               

serialport_handle: dw 0
serialport_name: db "COM1", 0

start:
call open_serialport_handle


open_serialport_handle proc near
  mov ax, 0x3D01
  mov dx, offset serialport_name
  int 0x21
  mov serialport_handle, ax
  ret
open_serialport_handle endp

syscall_str: db "Syscall ", 0
int21_wrapper proc near
  call set_kernel_21h
  call set_this_psp

  mov bx, offset syscall_str
  call writestr_serport

  0xEA
  int21_handler: dd 0 

  call set_program_psp
  call set_this_21h
  iret
int21_wrapper endp

set_kernel_21h proc near
  push ds
  push bx
  push ax

  xor ax, ax
  mov ds, ax
  mov bx, 0x21*4

  mov ax, word ptr int21_handler
  mov [bx], ax
  mov ax, word ptr int21_handler+2
  mov [bx+2], ax

  pop ax
  pop bx
  pop ds
  ret
set_kernel_21h endp

set_this_21h proc near
  push ds
  push bx
  push ax

  xor ax, ax
  mov ds, ax
  mov bx, 0x21*4

  mov ax, offset int21_wrapper
  mov word ptr [bx], ax
  mov ax, cs
  mov word ptr [bx+2], ax

  pop ax
  pop bx
  pop ds
  ret
set_this_21h endp

program_psp: dw 0
set_this_psp proc near
  push ax
  push bx
  mov ah, 0x51
  int 0x21
  mov program_psp, bx

  mov bx, cs
  mov ah, 0x50
  int 0x21
  pop bx
  pop ax
  ret
set_this_psp endp

set_program_psp proc near
  push ax
  push bx
  mov ah, 0x50
  mov bx, program_psp
  int 0x21
  pop bx
  pop ax
  ret
set_program_psp endp

; bx == pointer to string
writestr_serport proc near
  push ax
  push cx
  mov ah, 0x40
  mov bx, serialport_handle
  push bx
  xor cx, cx
  writestr_serport_strlen:
  test byte ptr [bx], 0xFF
  jnz writestr_serport_strlen_end
  inc cx
  jmp writestr_serport_strlen
  writestr_serport_strlen_end:
  pop bx
  int 0x21
  pop cx
  pop ax
writestr_serport endp

_TEXT ENDS

END
