#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
#include <string.h>

char filenames[13] = "*.*";

char flags = 0;
#define FLAG_R 0x01
#define FLAG_H 0x02
#define FLAG_S 0x04
#define FLAG_A 0x08

#define _A_SYMLINK 0x40

void set_attrs(void)
{
  struct find_t dta;
  int rc;
  unsigned char attr;
  char attrstr[] = "A__SHR";

  rc = _dos_findfirst(filenames, ~(_A_SUBDIR | _A_SYMLINK), &dta);
  while(!rc)
  {
    attr = dta.attrib;
    if(flags)
    {
      if(flags & FLAG_R) attr |= _A_RDONLY;
      else if(flags & (FLAG_R<<4)) attr &= ~_A_RDONLY;
      if(flags & FLAG_H) attr |= _A_HIDDEN;
      else if(flags & (FLAG_H<<4)) attr &= ~_A_HIDDEN;
      if(flags & FLAG_S) attr |= _A_SYSTEM;
      else if(flags & (FLAG_S<<4)) attr &= ~_A_SYSTEM;
      if(flags & FLAG_A) attr |= _A_ARCH;
      else if(flags & (FLAG_A<<4)) attr &= ~_A_ARCH;
      _dos_setfileattr(dta.name, attr);
    }
    if(attr & _A_ARCH) attrstr[0] = 'A';
    else attrstr[0] = '_';
    if(attr & _A_SYSTEM) attrstr[3] = 'S';
    else attrstr[3] = '_';
    if(attr & _A_HIDDEN) attrstr[4] = 'H';
    else attrstr[4] = '_';
    if(attr & _A_RDONLY) attrstr[5] = 'R';
    else attrstr[5] = '_';

    printf("%12s %s\n", dta.name, attrstr);

    rc = _dos_findnext(&dta);
  }
}

void parse_args(int argc, char *argv[])
{
  unsigned n;

  for(n=1;n<argc;n++)
  {
    if(argv[n][0] == '+') switch(argv[n][1] & 0x1F)
    {
      case ('A' & 0x1F): flags |= FLAG_A; break;
      case ('S' & 0x1F): flags |= FLAG_S; break;
      case ('H' & 0x1F): flags |= FLAG_H; break;
      case ('R' & 0x1F): flags |= FLAG_R; break;
    }
    else if(argv[n][0] == '-') switch(argv[n][1] & 0x1F)
    {
      case ('A' & 0x1F): flags |= FLAG_A<<4; break;
      case ('S' & 0x1F): flags |= FLAG_S<<4; break;
      case ('H' & 0x1F): flags |= FLAG_H<<4; break;
      case ('R' & 0x1F): flags |= FLAG_R<<4; break;
    }
    else strncpy(filenames, argv[n], sizeof(filenames)-1);
  }
}

int main(int argc, char *argv[])
{
  parse_args(argc, argv);
  set_attrs();

  return 0;
}
