#include <fcntl.h>
#include <io.h>

void parse_source(char *source, char *script, char *cmd)
{
  char *ls = strrchr(source, '\\');
  char lschr;
  if(!ls) ls = strrchr(source, '/');
  if(!ls) ls = strrchr(source, ':');

  if(ls)
  {
    sprintf(script, "FOR %%F IN (%s) DO %s ", source, cmd);
    lschr = *ls;
    *ls = 0;
    strcat(script, source);
    sprintf(script, "%s%c%%F ", script, lschr);
    *ls = lschr; // for MOVE cmd...
  }
  else
  {
    sprintf(script, "FOR %%F IN (%s) DO %s %%F ", source, cmd);
  }
}

inline int parsecopy(char *cmd, char **name1, char **name2)
{
  unsigned targetlen, srclen;
  unsigned char script[CMDLEN];

  if(!cmd || !*cmd)
  {
    errnoargs:
    puts("Arguments required");
    return 1;
  }

  *name1 = cmd+1;
  if(!**name1)
    goto errnoargs;


  if(*name2 = strchr(*name1, ' '))
    *(*name2)++ = 0;
  else
    *name2 = &(*name1)[strlen(*name1)];

  // if the source argument is a directory
  srclen = strlen(*name1);
  if((*name1)[srclen-1] == '\\' || (*name1)[srclen-1] == '/'
     || (*name1)[srclen-1] == ':')
    goto errnoargs;

  // if the target argument is missing
  if(!(targetlen = strlen(*name2)))
  {
    parse_source(*name1, script, "COPY");
    strcat(script, ".\\%F");
    puts(script);
    parse_command(script, 0, 0, 0);
    return 2;
  }
  // if the target argument is a directory
  else if((*name2)[targetlen-1] == '\\' || (*name2)[targetlen-1] == '/'
          || (*name2)[targetlen-1] == ':')
  {
    copytodir:
    parse_source(*name1, script, "COPY");
    strcat(script, *name2);
    strcat(script, "%F");
    puts(script);
    parse_command(script, 0, 0, 0);
    return 2;
  }
  else if(exists(*name2))
  {
    if(is_dir(*name2))
    {
      strcat(*name2, "\\");
      goto copytodir;
    }
  }

  return 0;
}

int copy(char *cmd)
{
  int retval = 0;
//  FILE *fp1, *fp2;
  unsigned int fd1, fd2 = -1;
  char *name1, *name2;
//  int c;
  unsigned rc, rc2;
  unsigned long bc = 0;
  unsigned long l;
  unsigned char ready, ready2;
  void __far *buff;
  char erroropen[] = "Error when opening file ";
  unsigned copy_count;
  unsigned long ld;

  if(parsecopy(cmd, &name1, &name2))
    return 0;

  buff = _fmalloc(copy_count = 9*1024);
  if(!buff)
    buff = malloc(copy_count = 1024);
  if(!buff)
  {
    puts(nomemoryerror);
    return 1;
  }

  fd1 = open(name1, O_RDONLY | O_BINARY);
  if(fd1 != -1)
  {
    fd2 = open(name2, O_WRONLY | O_TRUNC | O_CREAT | O_BINARY, S_IRWXU);

    if(fd2 == -1)
    {
      close(fd1);
      printf("%s%s: %s\n", erroropen, name2, strerror(errno));
      openerror:
      retval = 1;
      goto freebuff;
    }
  }
  else
  {
    printf("%s%s: %s\n", erroropen, name1, strerror(errno));
    goto openerror;
  }

  l = lseek(fd1, 0, SEEK_END);
  lseek(fd1, 0, SEEK_SET);

  printf("Copying file %s (%lu bytes)\n", name1, l);
//  while((rc = read(fd1, buff, copy_count)) > 0)
  while(!_dos_read(fd1, buff, copy_count, &rc) && rc)
  {
    bc += rc;
//    if(write(fd2, buff, rc) != rc)
    if(_dos_write(fd2, buff, rc, &rc2) || rc2 != rc)
    {
      puts("\nError writing file");
      retval = 1;
      goto freefds;
    }
    ld = l >> 6;
    if(ld)
    {
      ready = 100 * (bc>>6) / (ld);
      if(ready != ready2)
      {
        printf("\r%u%% ready", ready);
        fflush(stdout);
        ready2 = ready;
      }
    }
  }

  printf("\n");

  freefds:

  close(fd1);
  close(fd2);

  freebuff:
  if(copy_count > 1024)
    _ffree(buff);
  else
    free((void *)buff);
  return retval;
}
