#include <stdio.h>
#include <stdlib.h>
#include <direct.h>
#include <dos.h>
#include <string.h>
#include <fcntl.h>
#include <io.h>
#include <conio.h>

#define _A_SYMLINK 0x40

unsigned depth = 0;

char target_dir[65];
char target_file[82];

unsigned char flags = 0;
#define FLAG_Y 0x01
#define FLAG_V 0x02
#define FLAG_X 0x04

unsigned long dir_count = 1;
unsigned long file_count = 0;
unsigned long file_size = 0;

int deltree(void)
{
  struct find_t dta;
  int rc;
  unsigned n;
  unsigned int attrib;
  char *dirptr;
  char allfiles[] = "*.*";

  getcwd(target_file, sizeof(target_file));
  printf("Directory: %s\n", target_file);

  rc = _dos_findfirst(allfiles, ~(_A_SUBDIR | _A_SYMLINK), &dta);
  if(!rc) do
  {
    printf("Delete file %s\n", dta.name);
    file_count++;
    file_size += dta.size;
    if(!(flags & FLAG_X))
      if(remove(dta.name))
      {
        puts("Cannot delete file");
        return 1;
      }
  }
  while(!(rc = _dos_findnext(&dta)));
  
  rc = _dos_findfirst(allfiles, _A_SUBDIR, &dta);
  if(!rc) do
  {
    if((dta.attrib & _A_SUBDIR) && !(dta.attrib & _A_SYMLINK)
       && dta.name[0] != '.')
    {
      chdir(dta.name);
      depth++;
      dir_count++;
      if(deltree())
        return 1;
      if(!(flags & FLAG_X))
        if(rmdir(dta.name))
        {
          printf("Cannot delete directory %s\n", dta.name);
          return 1;
        }
    }
  }
  while(!(rc = _dos_findnext(&dta)));

  if(depth)
  {
    chdir("..");
    depth--;
  }

  return 0;
}

void show_help(void)
{
  puts("Deletes a directory and its contents.");
  puts("Arguments:");
  puts("/Y: Does not ask for confirmation");
  puts("/V: Show count of deleted files of directories and their size");
  puts("/X: Just lists files, does not delete them");
  exit(0);
}

char *parse_args(int argc, char *argv[])
{
  unsigned n;
  char *retval = 0;
  for(n=1;n<argc;n++)
  {
    if(argv[n][0] == '/')
    {
      switch(argv[n][1] & 0x1F)
      {
        case ('?' & 0x1F):
          show_help();
        case ('Y' & 0x1F):
          flags |= FLAG_Y;
          break;
        case ('V' & 0x1F):
          flags |= FLAG_V;
          break;
        case ('X' & 0x1F):
          flags |= FLAG_X;
          break;
      }
      continue;
    }
    if(!retval)
      retval = argv[n];
    else
      return 0;
  }
  return retval;
}

int main(int argc, char *argv[])
{
  unsigned l;
  char old_cwd[65];
  char *target;

  if(argc < 2)
  {
    puts("Target required");
    return 1;
  }

  target = parse_args(argc, argv);

  if(!(flags & FLAG_Y))
  {
    printf("Delete directory %s and all its subdirectories? (y/N)\n", target);
    if((getch() & 0x1F) != ('Y' & 0x1F))
      return 0;
  }

  getcwd(old_cwd, sizeof(old_cwd));
  if(target[1] == ':')
  {
    printf("Change drive to %c\n", target[0]);
    _dos_setdrive(target[0] & 0x1F, 0);
  }
  printf("Change directory to %s\n", target);
  if(chdir(target))
  {
    puts("Error");
    return 1;
  }
  while(1)
  {
    l = strlen(target_dir)-1;
    if(target_dir[l] == '\\' || target_dir[l] == '/')
      target_dir[l] = 0;
    else
      break;
  }
  deltree();
  printf("Change drive to %c\n", old_cwd[0]);
  _dos_setdrive(old_cwd[0] & 0x1F, 0);
  printf("Change directory to %s\n", old_cwd);
  chdir(old_cwd);
  rmdir(target);

  if(flags & FLAG_V)
  {
    printf("Deleted %lu files and %lu directories. Total size of the deleted \
files was %lu bytes.\n", file_count, dir_count, file_size);
  }

  return 0;
}
