int run_batch_wsargs(char *batch, char *args, int *rc);
int istrncmp(char*, char*, unsigned);

/*
  Returns one path from PATH environment variable
  This function is meant to be called in a loop, where the counter starts 
  from 0. The counter variable is passed to this function as a second argument
*/

static char *get_paths(char *pathenv, unsigned int pathnum)
{
  unsigned int n=0;
  static char retval[67];

  if(!pathenv)
    return 0;

  while(pathnum--)
  {
    if(pathenv[n] == ';')
      pathenv += n+1;
    if(!pathenv[n] || !*pathenv)
    {
      return 0;
    }
    for(n=0;pathenv[n] && pathenv[n]!=';';n++)
    {
      retval[n] = pathenv[n];
    }
    retval[n] = 0;
  }

  return retval;
}

#define MAX_PATH 82

char *find_executable_indir(char *program)
{
  unsigned n = 0;
  char *ext[] = { dotbat, ".EXE", ".COM" };
  char *ptr = &program[strlen(program)];
  struct find_t fileinfo;
  char *filename;
  char *eptr;

  if(!(filename = strrchr(program, '\\')))
    filename = program;
  else
    filename++;

  if(eptr = strchr(filename, '.'))
  {
    for(n=3;n--;)
      if(!istrncmp(eptr, ext[n], 4))
        break;
    if(n == -1)
      return 0;
    goto nostrcpy;
  }

  for(n=3;n--;)
  {
    strcpy(ptr, ext[n]);
    nostrcpy:if(!_dos_findfirst(program, _A_NORMAL, &fileinfo))
      return program;
    if(eptr)
      break;
  }
  return 0;
}

/*
This function searches executable files from $PATH

Arguments: a pointer to a string containing the filename of the program executable

Returns: Pointer to a string containing full path to the executable file
*/
static char *find_executable(char *program)
{
  unsigned int n;
  char *pathp;
  static char programpath[MAX_PATH];
  char *path = getenv("PATH");
  
  // if found in current working directory, return normally
  strcpy(programpath, program);
  if(find_executable_indir(programpath))
    return programpath;

  // else search from PATH
  for(n=1;;n++)
  {
    if(!(pathp = get_paths(path, n)))
    {
      return 0;
    }
    sprintf(programpath, "%s\\%s", pathp, program);
    if(find_executable_indir(programpath))
      return programpath;  
  }
}


unsigned code_segment(void);
#pragma aux code_segment = \
  "mov ax, cs" \
  value [ax];

int update_own_environment(void)
{
  unsigned env_seg = *(unsigned __far*)MK_FP(code_segment(), 0x2C);
  char __far *environment = MK_FP(env_seg, 0);
  char __far *temp, __far *tptr;
  char **envs = environ;
  unsigned l;
  unsigned s;

  temp = _fmalloc(2048);
  if(!temp) return 1;

  for(s=0,tptr=temp;*envs;)
  {
    l = strlen(*envs) + 1;
    _fmemcpy(tptr, *envs, l);
    tptr += l;
    s += l;
    envs++;
  }
  *tptr = 0;

  _fmemcpy(environment, temp, s+1);
  _ffree(temp);

  return 0;
}


/*
  This function runs executable *path with arguments *arg
  
  Returns: 0 if success, DOS error code if error
*/

unsigned dos_run_program(char __far *path, void __far *parm_block);
#pragma aux dos_run_program = \
  "push bp" \
  "push si" \
  "push di" \
  "push ds" \
  "mov ds, cx" \
  "mov ax, 0x4B00" \
  "int 0x21" \
  "jnc no_error" \
  "not ax" \
  "inc ax" \
  "jmp end" \
  "no_error:" \
  "mov ah, 0x4D" \
  "int 0x21" \
  "end:" \
  "pop ds" \
  "pop di" \
  "pop si" \
  "pop bp" \
  value [ax] parm [cx dx] [es bx];

unsigned dosexec(char *path, char *arg)
{
  unsigned short parameter_block[7];
  char dos_args[128] = { 0x00, 0x0D };
  unsigned retval;
  int rc;
  char *command = path;

  if(!(path = find_executable(path)))
  {
    outofmemory:
    printf("Invalid command or file name \"%s\" (%s)\n", command, strerror(errno));
    invalidcommand:errorlevel = 9009;
    return 0;
  }
  if(!strcmp(strrchr(path, '.'), dotbat))
  {
    if(!(run_batch_wsargs(path, arg, &rc)))
      printf("Batch");
    retval = !!batch_depth;
    goto end;
  }

  if(update_own_environment())
    goto outofmemory;

  if(arg)
  {
    dos_args[0] = _fstrlen(arg);
    _fmemcpy(&dos_args[1], arg, dos_args[0]);
    dos_args[dos_args[0]+1] = 0x0D;
  }

  _fmemset(parameter_block, 0, sizeof(parameter_block));
  
//  parameter_block[0] = 0; // parent environment
  *(char __far**)&parameter_block[1] = dos_args;

//  _heapshrink();

  errorlevel = dos_run_program(path, parameter_block);
  if(errorlevel < 0)
  {
    printf("DOS Error: %.2X\n", -errorlevel);
    goto invalidcommand;
  }
  retval = 0;

//  _heapgrow();
  printf("Child");

  end:
  printf(" exited with return code %i\n", errorlevel);

  return retval;
}


