#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <string.h>
#include <malloc.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <io.h>
#include <dos.h>

#include "dosexec.c"

char __far *video = (void __far*)0xB8000000L;

char buff[80];

char bios_floppy_count;

unsigned char target_drive = 2;

void fill_screen(void)
{
  unsigned n;

  for(n=0;n<80;n++)
  {
    video[n<<1] = ' ';
    video[(n<<1)+1] = 0x70;
  }
  for(;n<2000-80;n++)
  {
    video[n<<1] = ' ';
    video[(n<<1)+1] = 0x03;
  }
}

void print_text(unsigned row, unsigned col, char *str)
{
  while(*str)
  {
    video[(row*80 + col)<<1] = *str;
    *str++;
    col++;
  }
}

void print_status(char *str)
{
  unsigned n;
  for(n=0;n<80;n++)
  {
    video[(24*80 + n)<<1] = ' ';
    video[((24*80 + n)<<1)+1] = 0x70;
  }
  print_text(24, 0, str);
}

void print_screen(void)
{
  fill_screen();
  print_text(0, 10, "ST-DOS SETUP");

}

void start(void)
{
  print_screen();

  print_text(10, 6, "Welcome to the ST-DOS installer!");
  print_text(12, 2, "WARNING: This program destroys all data on your hard disk.");
  print_text(13, 2, "If this is not what you want, press ESC to quit.");
  print_text(14, 2, "Otherwise press ENTER to begin installing ST-DOS.");

  print_status("ST-DOS installer v. 1.3 | [ESC] QUIT - [ENTER] CONTINUE");

  getkey:switch(getch())
  {
    case 27: exit(0);
    case 13: return;
    default: goto getkey;
  }
}

struct harddisk
{
  unsigned cylinders;
  unsigned char sectors;
  unsigned char heads;
};

int detect_harddisk(struct harddisk *hd)
{
  unsigned cyl;
  unsigned char hds;
  unsigned char sec;
  unsigned char status;
  unsigned char drive = target_drive + 0x80;

  drive -= bios_floppy_count;

  __asm
  {
    mov ah, 8
    mov dl, drive
    int 0x13
    mov sec, cl
    and sec, 0x3F
    xchg ch, cl
    rol ch, 1
    rol ch, 1
    and ch, 3
    mov cyl, cx
    mov hds, dh
    mov status, ah
  }

  hd->cylinders = cyl;
  hd->sectors = sec;
  hd->heads = hds;

  return status;
}

void format_disk(struct harddisk *hd, unsigned cluster_size,
                 unsigned sectors_per_fat, unsigned long total_sectors)
{
  char formatprg[] = "\\FORMAT.COM";
  char formatargs[127];
  unsigned n;
  
  for(n=0;n<2000;n++)
  {
    video[n<<1] = ' ';
    video[(n<<1) + 1] = 0x0F;
  }

  sprintf(formatargs, "DRV:%c 512 %u 1 2 224 %lu %u %u %u 0 16", 'A' + target_drive, cluster_size, total_sectors,
          sectors_per_fat, hd->sectors, hd->heads);
//  printf("Format args: %s\n", formatargs);
  if(dosexec(formatprg, formatargs))
    exit(1);

  print_screen();

  print_text(10, 2, "Disk format complete.");

}

void mount_root(unsigned long part_size)
{
  unsigned char mountstruct[16] = {
  2, 0,
  };
  unsigned char *const driveltr = mountstruct;
  int rc;
  *driveltr = target_drive; 
  *(unsigned*)&mountstruct[2] = 512;
  *(unsigned long*)&mountstruct[4] = part_size;
  *(unsigned long long*)&mountstruct[8] = 0;
  __asm
  {
    // unmount drive C
    mov ah, 0x6A
    mov cx, 5
    mov dx, ds
    mov bx, driveltr
    int 0x21
    mov rc, ax
    jc end
    // mount drive C from root
    mov ah, 0x6A
    mov cx, 4
    mov di, driveltr
    int 0x21
    jnc end
    mov rc, ax
    end:
  }

  if(rc)
  {
    print_text(18, 2, "Error when trying to remount target drive!");
    getch();
  }

}

void autoformat_2(struct harddisk *hd, unsigned long sector_count)
{
  unsigned long mbs = ((unsigned long)hd->heads * hd->sectors * hd->cylinders) / 2 / 1024;
  unsigned cluster_size;
  unsigned long sectors_per_fat;
  unsigned long total_clusters;

#define MAX_FS_SIZE 2047

  print_screen();

  if(mbs > MAX_FS_SIZE)
  {
    print_text(10, 2, "The maximum supported filesystem size is currently 2 gigabytes.");
    print_text(11, 2, "Your hard disk is larger than that.");

    mbs = MAX_FS_SIZE;
    sector_count = (unsigned long)MAX_FS_SIZE*1024*2;
  }
  sprintf(buff, "Press ENTER to create a %lu MB filesystem.", mbs);
  print_text(12, 2, buff);
  print_text(14, 2, "Calculated values:");

  if(mbs > 10) cluster_size = 8;
  else cluster_size = 4;

  total_clusters = sector_count - 1 - (224 >> 5);
  total_clusters /= cluster_size;

  while(total_clusters >= 0xFFF7)
  {
    cluster_size <<= 1;
    total_clusters >>= 1;
  }

  total_clusters += 2; // media descriptor && end of file

  sectors_per_fat = total_clusters / 256;
  if((unsigned long)sectors_per_fat * cluster_size * 256 < sector_count - 1 - (224 >> 5))
    sectors_per_fat++;

  sprintf(buff, "Sectors per cluster: %u", cluster_size);
  print_text(15, 2, buff);
  sprintf(buff, "Total clusters: %lu", total_clusters - 2);
  print_text(16, 2, buff);
  sprintf(buff, "Sectors per FAT: %lu", sectors_per_fat);
  print_text(17, 2, buff);

  print_status("[ENTER] Create filesystem - [ESC] Quit");

  getkey:switch(getch())
  {
    case 13:
      mount_root(sector_count);
      format_disk(hd, cluster_size, sectors_per_fat, sector_count);
      return;
    case 27:
      exit(0);
    default: goto getkey;
  }
}

void autoformat(void)
{
  struct harddisk hd;
  unsigned long hd_size;

  print_screen();

  if(detect_harddisk(&hd))
  {
    print_text(10, 2, "The BIOS returned an error while trying to detect your hard disk");
    print_text(11, 2, "parameters.");
    print_text(12, 2, "Press any key to exit.");
    getch();
    exit(1);
  }
  else
  {
    hd.cylinders++;
    hd.heads++;
    sprintf(buff, "Your hard disk has %u cylinders, %u sectors and %u heads.",
              hd.cylinders, hd.sectors, hd.heads);
    print_text(10, 2, buff);
    hd_size = (unsigned long)hd.heads * hd.cylinders * hd.sectors;
    sprintf(buff, "The size of the disk was calculated to be %lu megabytes.", hd_size/1024/2);
    print_text(11, 2, buff);
    print_text(12, 2, "Is this is correct, press ENTER. Otherwise press any other key to quit.");
    print_status("[ENTER] Continue formatting");
    switch(getch())
    {
      case 13:
        autoformat_2(&hd, hd_size);
        return;
      default:
        exit(1);
    }
  }
}

void format(void)
{
  print_screen();
  print_text(10, 2, "The hard disk must be formatted before installing ST-DOS.");
  print_text(11, 2, "If you have already formatted your hard disk, press ENTER.");
  print_text(12, 2, "If you want that the installer formats your disk automatically, ");
  print_text(13, 2, "press A. Press ESC to quit the installer.");
  print_status("[ENTER] Continue without formatting - [A] Automatic format - [ESC] QUIT");

  getkey:switch(getch())
  {
    case 27: exit(0);
    case 'a': case 'A': autoformat(); return;
    case 13: print_screen(); return;
    default: goto getkey;
  }
}

char *dirlist[] =
{
  "DOS",
  "KEYB"
};

char *filelist[][2] =
{
  { "KERNEL.BIN", "" },
  { "COMMAND.COM", "" },
  { "COMDRV.EXE", "" },
  { "LPTDRV.EXE", "" },
  { "CONFIG.SYS", "" },
  { "MEM.COM", "DOS\\" },
  { "KEYMOUSE.COM", "DOS\\" },
  { "FORMAT.COM", "DOS\\" },
  { "MODE.COM", "DOS\\" },
  { "HEXDUMP.COM", "DOS\\" },
  { "MD5SUM.EXE", "DOS\\" },
  { "SYS.COM", "DOS\\" },
  { "BOOTCODE.086", "DOS\\" },
  { "MOUNT.COM", "DOS\\" },
  { "MKLINK.COM", "DOS\\" },
  { "MNTPARTS.COM", "" },
  { "KEYB.EXE", "DOS\\" },
  { "XCOPY.COM", "DOS\\" },
  { "DELTREE.COM", "DOS\\" },
  { "TREE.COM", "DOS\\" },
  { "DIRFIND.COM", "DOS\\" },
  { "ATTRIB.COM", "DOS\\" }
};

char *cdrom_filelist[][2] =
{
  { "ATAPITSR.EXE", "DOS\\" },
  { "CDDRV.EXE", "DOS\\" },
  { "ISO9660.EXE", "DOS\\" }
};

char install_cdrom = 0;


void print_copy_error(char *filename)
{
  sprintf(buff, "Error copying %s - press any key", filename);
  print_text(11, 2, buff);
  getch();
}

void copy_file(char *target, char *source)
{
  int tfd, sfd;
  unsigned char cbuff[1024];
  unsigned c;

  tfd = open(target, O_WRONLY | O_CREAT | O_TRUNC | O_BINARY, S_IRWXU);
  sfd = open(source, O_RDONLY | O_BINARY);

  if(tfd == -1 || sfd == -1)
  {
    print_copy_error(source);
  }

  while(c = read(sfd, cbuff, sizeof(cbuff)))
  {
    if(c == -1)
    {
      print_copy_error(source);
      break;
    }
    else
      if(write(tfd, cbuff, c) != c)
      {
        print_copy_error(source);
        break;
      }
  }

  if(close(tfd) | close(sfd))
  {
    print_copy_error(source);
  }
}

void copy_files_2(char *filelist[][2], unsigned count)
{
  unsigned n;
  char fnbuff[80];

  print_screen();
  print_text(10, 2, "Copying files...");
  for(n=0;n<count;n++)
  {
    sprintf(fnbuff, "%c:\\%s%s", target_drive + 'A', filelist[n][1], filelist[n][0]);
    sprintf(buff, "%u%% ready", n*100/count);
    print_text(11, 2, buff);
    sprintf(buff, "Copying file %s", fnbuff);
    print_status(buff);
    copy_file(fnbuff, filelist[n][0]);
  }
}

void copy_files(void)
{
  char fnbuff[80];
  unsigned n;
  print_screen();

  print_text(10, 2, "Creating directories...");
  for(n=0;n<sizeof(dirlist)/sizeof(char*);n++)
  {
    sprintf(fnbuff, "%c:\\%s", target_drive + 'A', dirlist[n]);
    sprintf(buff, "Creating directory %s", fnbuff);
    print_status(buff);
    mkdir(fnbuff);
  }

  copy_files_2(filelist, sizeof(filelist)/sizeof(filelist[0]));
}

char configsysopenerror[] = "Cannot open CONFIG.SYS!";
char configsyswriteerror[] = "Cannot write CONFIG.SYS!";

char *config_file_path(void)
{
  static char filename[] = "A:\\CONFIG.SYS";
  filename[0] = 'A' + target_drive;
  return filename;
}

void copy_cdrom(void)
{
  unsigned n;
  char *configline[] =
  {
    "DRIVER=DOS\\ATAPITSR.EXE\n",
    "DRIVER=DOS\\CDDRV.EXE\n",
    "DRIVER=DOS\\ISO9660.EXE\n"
  };

  FILE *fp;
  copy_files_2(cdrom_filelist, sizeof(cdrom_filelist)/sizeof(cdrom_filelist[0]));
  fp = fopen(config_file_path(), "at");
  if(!fp)
  {
    puts(configsysopenerror);
    return;
  }
  for(n=0;n<sizeof(configline)/sizeof(char*);n++)
    if(fwrite(configline[n], strlen(configline[n]), 1, fp) != 1)
      puts(configsyswriteerror);
  fclose(fp);
}

void install(void)
{
  print_text(11, 2, "The next step is to copy ST-DOS files to the hard disk.");
  print_text(12, 2, "Press ENTER to continue or ESC to quit.");
  print_status("[ENTER] Continue - [ESC] Quit");

  getkey1:switch(getch())
  {
    case 13: break;
    case 27: exit(0);
    default: goto getkey1;
  }

  copy_files();
}

void ask_cdrom(void)
{
  print_screen();
  print_text(10, 2, "Do you want to install CD-ROM drivers?");
  print_status("[Y] Yes - [N] No");

  getkey1: switch(getch())
  {
    case 'y': case 'Y':
      install_cdrom = 1;
      copy_cdrom();
      break;
    case 'n': case 'N':
      return;
    default: goto getkey1;
  }
}

struct keymap_list
{
  char filename[13];
  struct keymap_list *next;
};

void install_keymap(char *filename)
{
  FILE *fp;
  char configline[80];

  print_status("Installing keymap...");
  sprintf(configline, "%c:\\KEYB\\%s", target_drive + 'A', filename);
  copy_file(configline, filename);
  fp = fopen(config_file_path(), "at");
  if(!fp)
  {
    print_status(configsysopenerror);
    getch();
    return;
  }
  sprintf(configline, "DRIVER=DOS\\KEYB.EXE KEYB\\%s\n", filename);
  if(fwrite(configline, strlen(configline), 1, fp) != 1)
  {
    print_status(configsyswriteerror);  
    getch();
  }
  fclose(fp);
}

void select_keymap(void)
{
  struct find_t fileinfo;
  unsigned rc;
  struct keymap_list *keymap_list = calloc(1, sizeof(struct keymap_list));
  struct keymap_list *keymap_list_ptr = keymap_list;
  unsigned n;
  int c;
  unsigned char r;
  char buf[20];
  if(!keymap_list)
    return;

  rc = _dos_findfirst("*.MAP", _A_NORMAL, &fileinfo);
  if(!rc) while(1)
  {
    strcpy(keymap_list_ptr->filename, fileinfo.name);
    rc = _dos_findnext(&fileinfo);
    if(rc)
      break;
    keymap_list_ptr->next = calloc(1, sizeof(struct keymap_list));
    if(!keymap_list_ptr->next)
    {
      freekeymaps:do
      {
        keymap_list_ptr = keymap_list->next;
        free(keymap_list);      
        keymap_list = keymap_list_ptr;
      }
      while(keymap_list);
      return;
    }
    keymap_list_ptr = keymap_list_ptr->next;
  }

  print_screen();
  print_text(3, 2, "Choose the keymap that you want to use.");
  print_text(4, 2, "Press [ENTER] to use the BIOS default.");

  for(n=6,c='A',r=0,keymap_list_ptr=keymap_list;keymap_list_ptr;
      keymap_list_ptr=keymap_list_ptr->next,n++,c++)
  {
    if(n > 18)
    {
      n = 6;
      r += 20;
    }
    sprintf(buf, "[%c] %s", c, keymap_list_ptr->filename);
    print_text(n, 10+r, buf);
  }

  print_status("");

  keymap_getkey:c = getch();
  if(c == 13) goto freekeymaps;
  
  for(c=(c-'A')&0x1F,keymap_list_ptr=keymap_list;c--;)
    if(!(keymap_list_ptr = keymap_list_ptr->next))
      goto keymap_getkey;

  install_keymap(keymap_list_ptr->filename);

  goto freekeymaps;
}

void make_bootable(void)
{
  char sysargs[] = "DRV:C";
  sysargs[4] = target_drive + 'A';
  print_screen();
  print_text(10, 2, "Making the hard drive bootable...");
  print_status("");
  if(dosexec("\\SYS.COM", sysargs))
  {
    print_text(11, 2, "Error!");
    getch();
  }
}

void ask_target(unsigned char setup_drive)
{
  int c = bios_floppy_count + 'A';
  char text[] = "Select target drive: A";
  if(setup_drive == c)
    c++;

  print_screen();
  print_text(10, 2, text);
  print_status("[ENTER] Confirm");
  do
  {
    target_drive = (c - 'A') & 0x1F;
    text[strlen(text)-1] = target_drive + 'A';
    print_text(10, 2, text);
  }
  while((c = getch()) != 13);
}

void ready(void)
{
  print_screen();
  print_text(10, 2, "Your ST-DOS installation is now ready and bootable!");
  print_text(11, 2, "You can now remove the bootable floppy and reboot your computer.");
  print_text(12, 2, "Press any key to exit the installer.");
  getch();
}

void make_autoexec()
{
  FILE *fp;
  unsigned n;
  char *autoexec_line[] = 
  {
    "SET PATH=%COMDRV%:\\;%COMDRV%:\\DOS\n",
    "SET KEYBDIR=%COMDRV%:\\KEYB\n"
  };
  char filename[] = "A:\\AUTOEXEC.BAT";
  filename[0] += target_drive;

  print_screen();
  print_text(10, 2, "Creating your AUTOEXEC.BAT...");

  fp = fopen(filename, "wt");
  if(!fp)
  {
    print_text(11, 2, "Error while creating file!");
    presskey:print_text(14, 2, "Press any key to continue.");
    getch();
    return;
  }

  for(n=0;n<sizeof(autoexec_line)/sizeof(char*);n++)
  if(fwrite(autoexec_line[n], strlen(autoexec_line[n]), 1, fp) != 1)
  {
    print_text(12, 2, "Error while writing file!");
    goto presskey;
  }

  if(fclose(fp))
  {
    print_text(13, 2, "Error while closing file!");
    goto presskey;
  }
}

int main(int argc, char *argv[])
{
  unsigned char bios_equipment_flags = *(unsigned char __far*)MK_FP(0x40, 0x10);
  bios_floppy_count = bios_equipment_flags & 1;
  if(bios_floppy_count) bios_floppy_count += bios_equipment_flags >> 6;
  bios_floppy_count += bios_floppy_count & 1;

  start();
  ask_target(argv[0][0]);
  format();
  install();
  ask_cdrom();
  make_autoexec();
  select_keymap();
  make_bootable();

  ready();

  return 0;
}
