#include "types.c"

void putstr(char __far *str);
#pragma aux putstr parm [es si] modify exact [es];

void write_con(char __far *str, unsigned count);
#pragma aux write_con parm [es si] [cx] modify exact [es];

void call_idle_handler(void);
#pragma aux call_idle_handler modify exact [];

unsigned getstr(unsigned len, char __far *str);
#pragma aux getstr parm [cx] [es di] value [ax] modify exact [es ax];

extern unsigned initial_mcb;
extern unsigned char *initial_mcb_off;
extern unsigned char error_code;

//unsigned first_alloc(unsigned paragraphs);
//#pragma aux first_alloc parm [ax] value [ax];

unsigned char system_drive_type(void);

int memory_integrity_check(void);
//unsigned mcb_max_size(unsigned mcb);
unsigned new_alloc(unsigned paragraphs, unsigned owner_psp);
unsigned allocate_high(unsigned, unsigned);
//unsigned dma_alloc(unsigned paragraphs, unsigned owner_psp);
void shrink_alloc(unsigned mcb, unsigned new_size);
unsigned modify_alloc(unsigned mcb, unsigned new_size);
unsigned free_alloc(unsigned mcb);
void delete_alloc(unsigned mcb);
void delete_mcb(unsigned);
void free_psp_allocs(unsigned psp);
unsigned mcb_exists(unsigned);
unsigned free_paras(unsigned, unsigned, unsigned);
void set_mcb_type(unsigned, unsigned);
void set_mcb_owner(unsigned, unsigned);
int defrag_memory(void);
int free_usercache(void);

int init_timer_rtn(void);
void init_clock(void);

void stshell_parse_args(char __far*);

unsigned benchmark(unsigned *);
#pragma aux benchmark parm [di] value [ax];

//unsigned abs(int);

unsigned long free_bytes(unsigned char drive);

void invalidate_caches(unsigned char const);
int write_logical_sector(lbaindex_t const sector, unsigned char const disk_id);
int read_logical_sector(lbaindex_t const sector, unsigned char const disk_id, unsigned const count);
int disk_changed(unsigned char disk_id, unsigned long *);

void enable_caches();
void disable_caches();

unsigned next_handle_seg(unsigned);
int flush_handle(unsigned);
int flush_buffers(void);
void free_buffers(unsigned);
int write_to_buffer(unsigned handle_seg, unsigned count, void __far *data);
unsigned handle_buffer_size(unsigned);
int dup_handle(unsigned psp, unsigned orig_seg, unsigned req_id);
void sync_dups(unsigned handle_seg);

unsigned find_dta(unsigned);

int part_write(unsigned long, unsigned char);
int part_read(unsigned long, unsigned char, unsigned);
int add_partition(unsigned, lbaindex_t, unsigned long, unsigned char, unsigned, unsigned char __far*);
void remove_partition(unsigned);
unsigned char part2logicaldrive(unsigned char);
int unmount_partition(unsigned char, unsigned);
int mount_file(unsigned char __far*, unsigned char __far*);
int unmount_file(unsigned char);
int set_partition_size(unsigned char __far*);
void set_system_drive(void);

void stfs_unmount_partition(unsigned char);
 
int fsdriver_mount_partition(unsigned, unsigned char, char __far*);
int fsdriver_unmount_partition(unsigned, unsigned char);
unsigned fsdriver_raw_write(unsigned long, void __far*, unsigned, unsigned char);
unsigned fsdriver_raw_read(unsigned long, void __far*, unsigned, unsigned char);
void driver_func_entry(unsigned *, unsigned *, unsigned);
void driver_func_ret(unsigned, unsigned);
long driver_seek(unsigned, unsigned, long, unsigned);
int driver_write(unsigned, unsigned, char __far*, unsigned);
int driver_read(unsigned, unsigned, char __far*, unsigned);
int driver_open(unsigned, unsigned, unsigned);
int driver_close(unsigned, unsigned);
void driver_geterror(unsigned, unsigned);
int driver_cmd(unsigned, unsigned, void __far*);
//unsigned driver_get_dev_status(unsigned, unsigned);
unsigned long driver_ioctl(unsigned, unsigned, unsigned, unsigned char __far*, unsigned);

int open_dev(unsigned, unsigned, unsigned, unsigned);

int directory_entry(unsigned char drive, dirindex_t index, unsigned char __far *buff, unsigned count);

int mount_drive(unsigned char __far*, unsigned char __far*);
unsigned int read_file(unsigned long offset, dirindex_t __far *file_index, unsigned count, void __far *buff, unsigned handle_seg);
unsigned int write_file(unsigned long offset, dirindex_t __far *file_index, unsigned count, void __far *buff, unsigned handle_seg);

int memcmp(void __far *ptr0, void __far *ptr1, unsigned count);
#pragma aux memcmp parm [es di] [dx si] [cx] value [cx] modify exact [cx];
int strncmp(char __far *str0, char __far *str1, unsigned count);
int cistrncmp(char __far *, char __far*, unsigned);
unsigned strlen(char __far *str);
#pragma aux strlen parm [es di] value [ax] modify exact [di ax];
//char __far *strcpy(char __far *dst, char __far *src);
#define strcpy(dst, src) memcpy(dst, src, strlen(src)+1)
//char __far *strchr(char __far *str, char chr);
#define strchr(str, chr) memchr(str, chr, strlen(str)+1)
char __far *memchr(char __far *buf, char chr, unsigned count);
#pragma aux memchr parm [es di] [ax] [cx] value [es di] modify exact [es di];

char __far *strpbrk(char __far*, char __far*);

void check_midnight_flag(void);

void __far *memcpyr(void __far* const dst, void __far* const src, unsigned count);
#pragma aux memcpyr parm [es di] [dx si] [cx] value [es di] modify exact [];
void __far *nmemcpyr(void __far* const dst, void * const src, unsigned count);
#pragma aux nmemcpyr parm [es di] [si] [cx] value [es di] modify exact [];
void __far *memcpy(void __far * const dst, void __far * const src, unsigned count);
#pragma aux memcpy parm [es di] [dx si] [cx] value [es di] modify exact [];
void __far *nmemcpy(void __far * const dst, void * const src, unsigned count);
#pragma aux nmemcpy parm [es di] [si] [cx] value [es di] modify exact [];
void __far *memset(void __far * const dst, int byte, unsigned count);
#pragma aux memset parm [es di] [ax] [cx] value [es di] modify exact [ax];
void __far *nmemset(void * const dst, int byte, unsigned count);
#pragma aux nmemset parm [di] [ax] [cx] value [es di] modify exact [ax es];

char *hex2str(unsigned num);
#pragma aux hex2str parm [ax] value [ax] modify exact [ax];

void parse_config(dirindex_t index);

unsigned is_driver_name(char __far*, unsigned *, unsigned *);
int add_driver(char __far*, void __far*, unsigned);
int unload_driver(char __far*);
void handle_dev(unsigned, unsigned, unsigned);

unsigned write_drive(unsigned char, unsigned long, unsigned char __far*, unsigned);
unsigned read_drive(unsigned char, unsigned long, unsigned char __far*, unsigned);

int update_file_info_nohandle(dirindex_t __far*);
struct file_info file_info(unsigned char drive, dirindex_t file_index);
int set_file_info(unsigned char drive, dirindex_t file_index, struct file_info __far *info);
int getcwd(unsigned char drive, dirindex_t __far *index);
void chdir(unsigned char, dirindex_t __far*);
unsigned load_program(char __far *program, char __far *args, unsigned, struct mzload *);
void load_overlay(char __far *program, char __far*);

int run_program(char __far *program, char __far *args, unsigned env_seg);
#pragma aux run_program parm [dx ax] [es bx] [cx] value [ax];

int load_shell(char __far *program, char __far *args);
#pragma aux load_shell parm [dx ax] [es bx] value [ax];

void copy_psp(unsigned);
void build_psp(unsigned, unsigned, unsigned paragraphs, unsigned char __far *args);
int allocate_env_block(char __far*, unsigned old_envs);
//void free_program_resources(unsigned);

void start_program(unsigned cs, unsigned ip, unsigned ss, unsigned sp);
#pragma aux start_program parm [bx] [cx] [dx] [di] aborts;

void int21h_handler();
void int20h_handler();
void int23h_handler();

void set_vector(unsigned, void __far *);
#pragma aux set_vector parm [bx] [es si] modify exact [];

void __far *get_vector(unsigned);
#pragma aux get_vector parm [bx] value [es si] modify exact [es si];

void set_near_vector(unsigned, void *);
#pragma aux set_near_vector parm [bx] [si] modify exact [es];

unsigned find_handle(unsigned psp, unsigned handle);
unsigned file_longest_handle(dirindex_t __far*, unsigned long *length);
int new_handle(unsigned psp, unsigned type);
unsigned int write_handle(unsigned psp, unsigned handle, unsigned char __far *data, unsigned count);
unsigned int read_handle(unsigned psp, unsigned handle, unsigned char __far *data, unsigned count);
void delete_psp_handles(unsigned psp);
int delete_handle(unsigned, unsigned, unsigned char);

int initdisk(void);
//unsigned char physical2logicaldrive(unsigned char);
unsigned char logical2physicaldrive(unsigned char);
//unsigned char part2logicaldrive(unsigned);
unsigned char part2physicaldrive(unsigned char);
int init_fs_driver(void);
//char __far *memtoupper(char __far *, unsigned);
//char __far *strtoupper(char __far *);
char toupper(char);
int wccistrcmp(char __far*, char __far*);

dirindex_t get_file_index(unsigned char, char __far *, dirindex_t*);
void handle_file(unsigned handle, dirindex_t index, unsigned);
struct file_info find_file_with_wildcards(struct dta __far*);
char __far *istrchr(char __far*, char);
//char rtchars(char __far*);
char __far *change_file_dir(char __far*, dirindex_t *);
int change_file_drive(char __far*);

char getch(void);
#pragma aux getch value [al] modify exact [ax];
char putch(char chr);
#pragma aux putch value [al] parm [ax] modify exact [ax];

int chdrive(unsigned drive);
unsigned directory_path(char __far*, unsigned char);
int set_cwd(char __far*, dirindex_t *);
int get_symlink_path(dirindex_t, dirindex_t *, unsigned char, unsigned *, dirindex_t *);
int fs_changed(unsigned char);

int print_sp(void);
void free_space(unsigned char, struct diskfree *);
int drive_exists(unsigned char);
int partition_exists(unsigned char);
int print_regs(void);
unsigned load_exe(dirindex_t *program, struct mzload *mz_struct);

extern unsigned char error_class;
extern unsigned char suggested_action;
extern unsigned char error_locus;

extern unsigned char /*__based(__segname("_CODE"))*/ internal_flags;

char __far *chg2filedir(char __far *, dirindex_t *);
void chg2olddir(dirindex_t *);

void init_cache(void);
int free_caches(unsigned const, int const);
void allocate_more_caches(void);

unsigned kbhit(void);
#pragma aux kbhit parm [ax] modify exact [ax];

unsigned char bios2doserror(unsigned char);

unsigned char critical_error_handler(unsigned char, unsigned char, unsigned char);

void int1bh_handler();
void int24h_wrapper();

void set_memory_allocation_strategy(char);
unsigned char get_memory_allocation_strategy(void);

void free_old_dta_structs(void);

int delete_file(unsigned char drive, dirindex_t index, unsigned char);
dirindex_t create_file(unsigned char drive, char __far *name, unsigned char attr);
int update_file_info(unsigned handle_seg);
//int truncate_file(dirindex_t __far*, unsigned long);
int truncate_file(unsigned);
dirindex_t create_dir(unsigned char drive, char __far *name);
int rename_file(unsigned char drive, dirindex_t index, char __far *newname);

struct time htime(void);

void flush_caches(unsigned const);
#pragma aux flush_caches parm [ax];

unsigned make_more_memory(unsigned);

unsigned char drive_from_path(char __far *path);

dirindex_t path_last_index(dirindex_t __far*);
int mark_file_in_use(unsigned);

union stat_fss_info get_handle_static_info(unsigned char, dirindex_t);

void int15h_handler();
extern void __far *bios_int15_handler;
void set_int15h_handler();

struct filetime time2ftime(struct time time);
struct filedate date2fdate(struct date date);
struct time ftime2time(struct filetime time);
struct date fdate2date(struct filedate date);

void debug_eyecatcher(void);
#pragma aux debug_eyecatcher = \
  "db 'd'" "db 'e'" "db 'b'" "db 'u'" "db 'g'";
