#include "globals.c"
#include "macros.c"
#include "structs.c"

unsigned int21c3c(unsigned attr, char __far *filename);
#pragma aux int21c3c parm [cx] [es dx] value [ax] modify exact [];

extern char __based(__segname("_CODE")) console_filename[];

unsigned int21c3c(unsigned attr, char __far *filename)
{
  dirindex_t old_dir[MAX_DIR_DEPTH+2];
  int rc;
  unsigned devseg;
  unsigned devnum;
  unsigned partition;
  dirindex_t index;
  struct file_handle __far *handle_ptr;
  unsigned char newfile = 0;

  if(!cistrncmp(filename, console_filename, 12))
  {
    rc = new_handle(CURRENT_PSP, 0);
    if(rc >= 0) return rc;
    error_code = 0x04;
  }
  else if((devseg = is_driver_name(filename, &partition, &devnum))
          && devnum != -1)
  {
    if(!error_code)
      return open_dev(3, devseg, partition, devnum);
  }
  else
  {
    filename = chg2filedir(filename, old_dir);
    if(!error_code)
    {
      index = get_file_index(WORKING_DRIVE, filename, old_dir);
      if(error_code == 0x02) // if file does not exist, create file
      {
        newfile = 1;
        error_code = 0;
        if((index = create_file(WORKING_DRIVE, filename, attr)) == -1)
          error_code = 0x0E;
      }
      // if no error, file should now exist. Create handle for the file
      if(!error_code)
        if((rc = new_handle(CURRENT_PSP, 3)) >= 0)
        {
          handle_file(rc, index, newfile);
          if(!error_code)
          {
            handle_ptr = MK_FP(find_handle(CURRENT_PSP, rc), 0);
            if(handle_ptr->length) // truncate the file if it is not zero length
              write_handle(CURRENT_PSP, rc, 0, 0);
          }
        }
        else
          error_code = 0x04;
      chg2olddir(old_dir);
    }
  }
  
  return rc;
}
