#include "globals.c"
#include "macros.c"
#include "structs.c"

unsigned long int21c42(unsigned origin, unsigned handle, signed long count);
#pragma aux int21c42 parm [ax] [bx] [cx dx] value [dx ax] modify exact [];

unsigned long int21c42(unsigned origin, unsigned handle, signed long count)
{
  unsigned handle_seg = find_handle(CURRENT_PSP, handle);
  struct file_handle __far *handle_ptr;

  if(!handle_seg)
  {
    errorreturn:
    return count << 16; // preserve DX
  }

  origin >>= 8;

  handle_ptr = MK_FP(handle_seg, 0);

  if(handle_ptr->type & 0x4000)
    return driver_seek(handle_ptr->file[0], handle_ptr->file[1], count, origin);
  else
  {
    memset(&handle_ptr->file_fss_info, 0, sizeof(union file_fss_info));
//    handle_ptr->is_seekd = 1;
    switch(origin)
    {
      case 0:
        handle_ptr->offset = count;
        break;
      case 1:
        handle_ptr->offset += count;
        break;
      case 2:
        handle_ptr->offset = handle_ptr->length + count;
        break;
      default: error_code = 0x01;
        goto errorreturn;
    }
    sync_dups(handle_seg);
  }

  return handle_ptr->offset;
}
