#include "globals.c"
#include "macros.c"
#include "structs.c"


unsigned int21c4e(unsigned, unsigned, char __far*);
#pragma aux int21c4e parm [ax] [cx] [es dx] value [ax] modify exact [];

void free_old_dta_structs(void)
{
  unsigned segment = initial_mcb;
  struct mcb __far* mcb_ptr;
  struct dta __far* dta_ptr;
  unsigned next_seg;
  unsigned __far *ptr_to_dta;

  do
  {
    mcb_ptr = MK_FP(segment, 0);
    next_seg = mcb_ptr->next_mcb_seg;
    if(mcb_ptr->type == MCB_DTA)
    {
      dta_ptr = MK_FP(segment+MCB_PARAGRAPHS, 0);
      ptr_to_dta = dta_ptr->dta_ptr;
      // if the "reserved" part in the program's memory area does not contain
      // the ID of the allocated block anymore, the memory block can be freed
      if(*ptr_to_dta != dta_ptr->id)
        delete_mcb(segment);
    }
  }
  while(segment = next_seg);
}

// returns the segment of the kernel-side DTA struct
unsigned find_dta(unsigned id)
{
  struct dta __far *dta_ptr;
  struct mcb __far *mcb_ptr;
  unsigned segment = initial_mcb;
  unsigned next_seg;

  do
  {
    mcb_ptr = MK_FP(segment, 0);
    next_seg = mcb_ptr->next_mcb_seg;
    if(mcb_ptr->type == MCB_DTA)
    {
      dta_ptr = MK_FP(segment+MCB_PARAGRAPHS, 0);
      if(dta_ptr->id == id)
        return FP_SEG(dta_ptr);
    }
  }
  while(segment = next_seg);

  return 0;
}

// returns 0 if fails, else returns the segment of the kernel-side DTA struct
unsigned new_dta_struct(void)
{
  unsigned retval;
  struct dta __far *dta_ptr;

  retval = allocate_high((sizeof(struct dta)+0xF)>>4, 0);

  if(retval)
  {
    set_mcb_type(retval, MCB_DTA);
    set_mcb_owner(retval, CURRENT_PSP);
    dta_ptr = MK_FP(retval, 0);
    dta_ptr->dta_ptr = DTA_BUFFER;
    dta_ptr->id = DTA_ID;
    CURRENT_DTA_ID = DTA_ID;
    do
      DTA_ID++;
    while(find_dta(DTA_ID));
  }

  return retval;
}

unsigned int21c4e(unsigned ax, unsigned attrib, char __far *filename)
{
  struct file_info fileinfo;
  dirindex_t old_dir[MAX_DIR_DEPTH+2];
  struct dta __far *dta_ptr;
  unsigned dta_seg = find_dta(CURRENT_DTA_ID);

  if(!dta_seg)
  {
    new_dta:
    dta_seg = new_dta_struct();
    if(!dta_seg)
      return 0;
  }

  dta_ptr = MK_FP(dta_seg, 0);
  if(dta_ptr->dta_ptr != DTA_BUFFER)
    goto new_dta;

  filename = chg2filedir(filename, old_dir);
  dta_ptr->drive = WORKING_DRIVE;
  getcwd(WORKING_DRIVE, dta_ptr->path);
  dta_ptr->attr = attrib;
  dta_ptr->index = 0;

  if(!error_code)
  {
    memcpy(dta_ptr->filename, filename, FILENAME_LEN);
    fileinfo = find_file_with_wildcards(dta_ptr);
    if(!error_code)
    {
      *(unsigned long __far*)&DTA_BUFFER[0x1A] = fileinfo.size;
      DTA_BUFFER[0x15] = fileinfo.attr;
      *(struct filetime __far*)&DTA_BUFFER[0x16] = time2ftime(fileinfo.time);
      *(struct filedate __far*)&DTA_BUFFER[0x18] = date2fdate(fileinfo.date);
    }
    chg2olddir(old_dir);
  }

  return XCHG(ax);
}
