#include "globals.c"
#include "macros.c"
#include "structs.c"

unsigned int21c6d(unsigned, unsigned, void __far*);
#pragma aux int21c6d parm [ax] [bx] [es di] value [ax] modify exact [];

unsigned int21c6d(unsigned ax, unsigned parm, void __far *ptr)
{
  unsigned char function = ax >> 8;
  unsigned mcb;
  struct mcb __far *mcb_ptr;
  unsigned char old_memalloc_strategy;
  unsigned char dfc;

  switch(function)
  {
    case 0: // al == 0: set file buffer size
      flush_buffers();
      FILE_BUFFER_SIZE = parm;
    case 1: // al == 1: get file buffer size
      return FILE_BUFFER_SIZE;
    case 2: // al == 2: allocate user cache
      old_memalloc_strategy = get_memory_allocation_strategy();
      set_memory_allocation_strategy(MEMALLOC_STRATEGY_LAST | MEMALLOC_STRATEGY_KEEPTOPFREE);
      dfc = DONT_FLUSH_CACHES;
      DONT_FLUSH_CACHES = 1;
      mcb = new_alloc(parm, CURRENT_PSP);
      DONT_FLUSH_CACHES = dfc;
      set_memory_allocation_strategy(old_memalloc_strategy);    
      if(mcb)
      {
        mcb_ptr = MK_FP(mcb-MCB_PARAGRAPHS, 0);
        mcb_ptr->type = MCB_USERCACHE;
        mcb_ptr->usercache_freedptr = ptr;
        mcb_ptr->owner_psp = CURRENT_PSP;
      }
      return mcb;
      case 3: // disable cache
        disable_caches();
      return 0;
      case 4: // enable cache
        enable_caches();
      return 0;
  }
}
