#include "globals.c"
#include "macros.c"

char __based(__segname("_CODE")) errorstr1[] = 
"Unrecoverable error when ";

char __based(__segname("_CODE")) indisk[] = " in disk ";
char __based(__segname("_CODE")) indevice[] = " in device ";
char * __based(__segname("_CODE")) devicetype[] =
{
  indisk, indevice
};

char __based(__segname("_CODE")) errorstr2[] = 
"Choose one of the following:";

char __based(__segname("_CODE")) abortstr[] =
"[A]bort";
char __based(__segname("_CODE")) retrystr[] =
"[R]etry";
char __based(__segname("_CODE")) failstr[] =
"[F]ail";
char __based(__segname("_CODE")) ignorestr[] =
"[I]gnore";
char __based(__segname("_CODE")) helpstr[] =
"[H]elp";
char __based(__segname("_CODE")) comstr[] = ", ";

char __based(__segname("_CODE")) reading[] = "reading ";
char __based(__segname("_CODE")) writing[] = "writing ";

char * __based(__segname("_CODE")) rw[] = 
{
  reading, writing
};

char __based(__segname("_CODE")) systemfiles[] = "system files";
char __based(__segname("_CODE")) filesystem[] = "filesystem";
char __based(__segname("_CODE")) directory[] = "directory";
char __based(__segname("_CODE")) dataarea[] = "data area";
char * __based(__segname("_CODE")) area[] =
{
  systemfiles, filesystem, directory, dataarea
};

char __based(__segname("_CODE")) errorcodestr[] = 
  "Error code: ";

char __based(__segname("_CODE")) writeprotecterr[] = "Write protect";
char __based(__segname("_CODE")) unknownuniterr[] = "Unknown unit";
char __based(__segname("_CODE")) notready[] = "Not ready";
char __based(__segname("_CODE")) unknowncmd[] = "Unknown command";
char __based(__segname("_CODE")) dataerror[] = "Data error";
char __based(__segname("_CODE")) badrequest[] = "Bad request structure length";
char __based(__segname("_CODE")) seekerror[] = "Seek error";
char __based(__segname("_CODE")) unknownmediatype[] = "Unknown media type";
char __based(__segname("_CODE")) sectornotfound[] = "Sector not found";
char __based(__segname("_CODE")) outofpaper[] = "Out of paper";
char __based(__segname("_CODE")) writefault[] = "Write fault";
char __based(__segname("_CODE")) readfault[] = "Read fault";
char __based(__segname("_CODE")) generalfail[] = "General failure";

char * __based(__segname("_CODE")) strerrors[] =
{
  writeprotecterr,
  unknownuniterr,
  notready,
  unknowncmd,
  dataerror,
  badrequest,
  seekerror,
  unknownmediatype,
  sectornotfound,
  outofpaper,
  writefault,
  readfault,
  generalfail
};

char __based(__segname("_CODE")) help[] =
"This is a critical error handler.";

char __based(__segname("_CODE")) newline[] = "\r\n";

unsigned int24h_handler(unsigned di, unsigned ax);
#pragma aux int24h_handler parm [di] [ax] value [ax];
unsigned int24h_handler(unsigned di, unsigned ax)
{
  unsigned char errorcode = di;
  unsigned char drive = ax;
  unsigned char einfo = ax >> 8;
  unsigned char key;
  unsigned char retval;

  #define FAIL_ALLOWED (einfo & 0x08)
  #define RETRY_ALLOWED (einfo & 0x10)
  #define IGNORE_ALLOWED (einfo & 0x20)
  #define ABORT_ALLOWED (einfo & 0x40)

  while(1)
  {
    putstr(errorstr1);
    putstr(rw[einfo&1]);
    putstr(area[(einfo>>1)&3]);
    putstr(devicetype[!!(einfo&0x80)]);
    putstr(hex2str(drive));

    putstr(newline);
    putstr(errorcodestr);
    putstr(hex2str(errorcode));
    putch(' ');
    putstr(strerrors[errorcode]);
    putstr(newline);

    putstr(errorstr2);
    putstr(newline);

    if(FAIL_ALLOWED)
      putstr(failstr);
    if(RETRY_ALLOWED)
    {
      putstr(comstr);
      putstr(retrystr);
    }
    if(IGNORE_ALLOWED)
    {
      putstr(comstr);
      putstr(ignorestr);
    }
    if(ABORT_ALLOWED)
    {
      putstr(comstr);
      putstr(abortstr);
    }
    putstr(comstr);
    putstr(helpstr);
    putstr(newline);
 
    key = getch() & 0x1F;

    if(ABORT_ALLOWED && key == 0x01)
    {
      retval = CRITERR_ABORT;
      break;
    }
    if(FAIL_ALLOWED && key == 0x06)
    {
      retval = CRITERR_FAIL;
      break;
    }
    if(RETRY_ALLOWED && key == 0x12)
    {
      retval = CRITERR_RETRY;
      error_code = 0;
      break;
    }
    if(IGNORE_ALLOWED && key == 0x09)
    {
      retval = CRITERR_IGNORE;
      error_code = 0;
      break;
    }
    if(key == 'H' || key == 'h')
    {
      putstr(help);
      putstr(newline);
    }
  }  

  return ((unsigned short)einfo<<8) | retval;
}

unsigned char critical_error_handler(unsigned char drive, unsigned char einfo, unsigned char errorcode)
{
  unsigned char retval;

  retval = call_int24h_wrapper(errorcode, (einfo << 8) | drive);
  if(retval == CRITERR_ABORT)
    terminate_application();

  return retval;
}

