#include "globals.c"
#include "macros.c"

static void set_psp_vectors(unsigned segment)
{
  OLD_INT22_HDLR(segment) = get_vector(0x22);
  OLD_BREAK_HDLR(segment) = get_vector(0x23);
  OLD_CRITERR_HDLR(segment) = get_vector(0x24);
}

void copy_psp(unsigned segment)
{
  memcpy(MK_FP(segment, 0), MK_FP(CURRENT_PSP, 0), 0x100);
  set_psp_vectors(segment);
  PARENT_PSP(segment) = CURRENT_PSP;
}

void build_psp(unsigned segment, unsigned env_seg, unsigned paragraphs, unsigned char __far *args)
{
  unsigned char __far *psp = MK_FP(segment, 0);
  
//  psp[0] = 0xCD;
//  psp[1] = 0x20; // int 0x20
  RETURN_INT(segment) = 0x20CD; // int 0x20

  LAST_PARAGRAPH(segment) = segment + paragraphs;
  PSP_SEGMENT_SIZE(segment) = (paragraphs<<4)  -  0x100;


  set_psp_vectors(segment);
  set_vector(0x22, TERMINATE_ADDRESS);
 
  PARENT_PSP(segment) = CURRENT_PSP;
  
  ENVIRONMENT_SEG(segment) = env_seg;
  
  PSP_DOS_VERSION(segment) = DOS_VERSION | (DOS_MINOR_VERSION << 8);
  
  // int 0x21 + retf
  FARCALL_ENTRY(segment) = 0x21CD;
  psp[0x52] = 0xCB;

  memcpy(&psp[0x80], args, 0x80);
}
