.8086

.MODEL small

public init_stack_
public stack_top
public __EPI
public __PRO
public print_sp_
public print_regs_
public stack_panic
extern init_kernel_2_:BYTE
;extern stack_ready:BYTE
extern _configsys:BYTE
extern putstr_:BYTE
extern start_shell_:BYTE
extern hex2str_:BYTE
extern _allocstack:BYTE

_TEXT               SEGMENT BYTE PUBLIC USE16 'CODE'
                ASSUME CS:_TEXT                               

init_stack_ proc near
  mov ax, ds

  mov ss, ax
  mov sp, offset _configsys

  mov es, ax
  mov si, offset _allocstack
  call near ptr putstr_

  call near ptr init_kernel_2_

  stack_top:

  mov sp, offset stack_top
  and sp, 0xFFFE

  jmp near ptr start_shell_

;  stack_top:

init_stack_ endp

stack_overflow: db " Panic: Stack overflow!", 0
null_assignment: db " Panic: Null assignment detected!", 0

__EPI proc near
  cmp word ptr cs:[0], 0xC88C
  jne nullptrerror
  ret
  nullptrerror:
  mov ax, 0x0002
  int 0x10
  call print_sp_
  call print_regs_
  mov ax, cs
  mov es, ax
  mov si, offset ipstr
  call near ptr putstr_
  pop ax
  call print_reg
  mov si, offset null_assignment
  call near ptr putstr_
  cli
  hlt
__EPI endp

__PRO proc near
  cmp sp, 0x30
  jg stack_check_end
  stack_panic:
  mov ax, 0x0002
  int 0x10
  call print_sp_
  call print_regs_
  mov ax, cs
  mov es, ax
  mov si, offset ipstr
  call near ptr putstr_
  pop ax
  call print_reg
  mov si, offset stack_overflow
  call near ptr putstr_
  cli
  hlt
  stack_check_end:
  ret
__PRO endp


print_sp_ proc near
  push ax
  push si
  push es
  mov ax, cs
  mov es, ax

  mov si, offset spstr
  call near ptr putstr_

  mov ax, sp
  add ax, 6
  xchg ah, al
  call near ptr hex2str_
  mov si, ax
  call near ptr putstr_
  mov ax, sp
  add ax, 6
  call near ptr hex2str_
  mov si, ax
  call near ptr putstr_

  mov si, offset ssstr
  call near ptr putstr_

  mov ax, ss
  xchg ah, al
  call near ptr hex2str_
  mov si, ax
  call near ptr putstr_
  mov ax, ss
  call near ptr hex2str_
  mov si, ax
  call near ptr putstr_

  mov si, offset nlstr
  call near ptr putstr_

  pop es 
  pop si
  pop ax
  ret
  spstr: db "SP: ", 0
  ssstr: db 0x0D, 0x0A, "SS: ", 0
print_sp_ endp

nlstr: db 0x0D, 0x0A, 0x00

print_regs_ proc near
  push si
  push ax
  push es

  push cs
  pop es

  mov si, offset axstr
  call near ptr putstr_
  call print_reg

  mov si, offset bxstr
  call near ptr putstr_
  mov ax, bx
  call print_reg

  mov si, offset cxstr
  call near ptr putstr_
  mov ax, cx
  call print_reg

  mov si, offset dxstr
  call near ptr putstr_
  mov ax, dx
  call print_reg

  mov si, offset bpstr
  call near ptr putstr_
  mov ax, bp
  call print_reg

  mov si, offset nlstr
  call near ptr putstr_

  mov si, offset esstr
  call near ptr putstr_
  pop ax
  push ax
  call print_reg

  mov si, offset dsstr
  call near ptr putstr_
  mov ax, ds
  call print_reg

  mov si, offset sistr
  call near ptr putstr_
  mov si, sp
  mov ax, ss:[si+4]
  call print_reg

  mov si, offset distr
  call near ptr putstr_
  mov ax, di
  call print_reg

  mov si, offset nlstr
  call near ptr putstr_

  pop es
  pop ax
  pop si
  ret
  axstr: db "AX: ", 0
  bxstr: db " BX: ", 0
  cxstr: db " CX: ", 0
  dxstr: db " DX: ", 0
  bpstr: db " BP: ", 0

  esstr: db "ES: ", 0
  dsstr: db " DS: ", 0
  sistr: db " SI: ", 0
  distr: db " DI: ", 0
print_regs_ endp

ipstr: db "IP: ", 0

print_reg:
  push ax
  xchg ah, al
  call near ptr hex2str_
  mov si, ax
  call near ptr putstr_
  pop ax
  call near ptr hex2str_
  mov si, ax
  call near ptr putstr_
  
  ret


_TEXT ENDS

END
