#include "globals.c"
#include "macros.c"
#include "structs.c"

#define EPOCH_YEAR 1980
#define EPOCH_WEEKDAY 2

extern unsigned char day;
extern unsigned char month;
extern unsigned year;

#define IS_LEAP_YEAR(year) (!((year-EPOCH_YEAR) & 3))

extern unsigned char month_length[];

static unsigned char day_of_week(void)
{
  unsigned n;
  unsigned dayofweek = EPOCH_WEEKDAY - 1;

  // calculate the weekday of this year's january 1st
  for(n=EPOCH_YEAR;n<year;n++)
  {
    dayofweek++;
    if(IS_LEAP_YEAR(n))
      dayofweek++;
  }

  for(n=month-1;n--;)
    dayofweek += month_length[n];

  if(IS_LEAP_YEAR(year) && month>2)
    dayofweek++;

  dayofweek += day;

  return dayofweek % 7; 
}

void init_clock(void)
{
// todo: get date from CMOS if 286
  weekday = day_of_week();
}

inline void increment_day(void)
{
  day++;
  if(++weekday == 7) weekday = 0;
  if(day > month_length[month-1])
  {
    month++;
    day = 1;
  }
  if(month > 12)
  {
    year++;
    month = 1;
    init_clock();
  }
}

void check_midnight_flag(void)
{
  char __far *midnight_flag = MK_FP(0x40, 0x70);

  if(*midnight_flag)
  {
    *midnight_flag = 0;
    increment_day();
  }
}

extern void __far (*old_timer_rtn)();
void timer_rtn();
extern unsigned timer_stack_seg;

int init_timer_rtn(void)
{
  init_clock();
  set_near_vector(0x1C, timer_rtn);
  return 0;
}
