#include "globals.c"
#include "macros.c"

// case-insensitive strchr
char __far *istrchr(char __far *str, char chr)
{
  unsigned l = strlen(str)+1;
  chr = toupper(chr);

  while(l--)
  {
    if(toupper(*str) == chr)
      return str;
    str++;
  }
  return 0;
}

/*
 * Case-insensitive string comparison with wildcards
 * */
int wccistrcmp(char __far *keyword, char __far *str)
{
  while(*str && *keyword)
  {    
    if(*keyword == '?')
    {
      keyword++;
      str++;
      continue;
    }
    if(*keyword == '*')
    {
      keyword++;
      str = istrchr(str, *keyword);
      if(!str) return *keyword;
      continue;
    }
    if(toupper(*keyword) != toupper(*str))
      return 1;

    str++;
    keyword++;
  }
  return *keyword - *str;
}
